>From 0da820dd707c4b8008cdf6b84e659de4d2a73cb6 Mon Sep 17 00:00:00 2001
From: Joseph Tulou <brezhoneg1@yahoo.fr>
Date: Wed, 28 Jan 2009 12:04:01 +0100
Subject: [PATCH] scaling toggle support for opengl + a bug correction on i_changes indicator

---
 modules/video_output/opengl.c |   16 ++++++++++++++--
 1 files changed, 14 insertions(+), 2 deletions(-)

diff --git a/modules/video_output/opengl.c b/modules/video_output/opengl.c
index 568217e..f93e343 100644
--- a/modules/video_output/opengl.c
+++ b/modules/video_output/opengl.c
@@ -224,12 +224,15 @@ static int CreateVout( vlc_object_t *p_this )
     var_Create( p_sys->p_vout, "mouse-button-down", VLC_VAR_INTEGER );
     var_Create( p_sys->p_vout, "video-on-top",
                 VLC_VAR_BOOL | VLC_VAR_DOINHERIT );
+    var_Create( p_sys->p_vout, "scaling",
+                VLC_VAR_BOOL | VLC_VAR_DOINHERIT );
 
     var_AddCallback( p_sys->p_vout, "mouse-x", SendEvents, p_vout );
     var_AddCallback( p_sys->p_vout, "mouse-y", SendEvents, p_vout );
     var_AddCallback( p_sys->p_vout, "mouse-moved", SendEvents, p_vout );
     var_AddCallback( p_sys->p_vout, "mouse-clicked", SendEvents, p_vout );
     var_AddCallback( p_sys->p_vout, "mouse-button-down", SendEvents, p_vout );
+    var_AddCallback( p_vout, "scaling", SendEvents, p_sys->p_vout );
 
     return VLC_SUCCESS;
 }
@@ -454,9 +457,18 @@ static int Manage( vout_thread_t *p_vout )
 // to align in real time in OPENGL
     if (p_sys->p_vout->i_alignment != p_vout->i_alignment)
     {
-        p_vout->i_changes = VOUT_CROP_CHANGE;        //to force change
+        p_vout->i_changes |= VOUT_CROP_CHANGE;        //to force change
         p_sys->p_vout->i_alignment = p_vout->i_alignment;    
     }
+
+    /* forward signal that scaling toggle has changed */
+    if (p_vout->i_changes & VOUT_SCALE_CHANGE )
+    {
+        p_vout->i_changes &= ~VOUT_SCALE_CHANGE;
+ 
+        p_sys->p_vout->i_changes |= VOUT_SCALE_CHANGE;
+    }
+
     return i_ret;
 }
 
@@ -664,7 +676,7 @@ static int InitTextures( vout_thread_t *p_vout )
 }
 
 /*****************************************************************************
- * SendEvents: forward mouse and keyboard events to the parent p_vout
+ * SendEvents: forward mouse, keyboard and scaling events to the parent p_vout
  *****************************************************************************/
 static int SendEvents( vlc_object_t *p_this, char const *psz_var,
                        vlc_value_t oldval, vlc_value_t newval, void *_p_vout )
-- 
1.5.2.5

